package com.zipcodewilmington.froilansfarm.PartsOfFarm;

import com.zipcodewilmington.froilansfarm.Crops.*;
import com.zipcodewilmington.froilansfarm.Fertilizable;
import com.zipcodewilmington.froilansfarm.Harvestable;

import java.util.Arrays;
import java.util.HashMap;

public class Field implements Harvestable, Fertilizable {

    int numberOfRows = 0;
    CropRow[] fieldContents = new CropRow[numberOfRows];
    boolean isFertilized = false;


    public Field(int numberOfRows) {
        this.isFertilized = false;
        this.numberOfRows = numberOfRows;
        this.fieldContents = new CropRow[this.numberOfRows];
    }

    public boolean isFertilized() {
        return isFertilized;
    }

    public void addCropRow(CropRow newRow, int rowNumber) {

        this.fieldContents[rowNumber - 1] = newRow;
    }

    public void harvest() {
        if(!this.isFertilized) {
            System.out.println("You must fertilize the field before you can harvest");
        } else {
            if (this.numberOfRows != 0) {
                for (CropRow row : this.fieldContents) {
                    System.out.print(row.getCrop() + " ");
                    Crop current = row.getCrop();
                    row.setCrop(null);
                    if(current instanceof CornStalk) {
                        EarOfCorn.addCorn(12);
                    } else if(current instanceof TomatoPlant) {
                        Tomato.addTomato(20);
                    }
                }
            } else {
                System.out.println("The field is empty.");
            }
        }
    }

    public void fertilize() {
        this.isFertilized = true;
    }
}
