package com.zipcodewilmington.froilansfarm.People;

import com.zipcodewilmington.froilansfarm.*;
import com.zipcodewilmington.froilansfarm.Animals.Horse;
import com.zipcodewilmington.froilansfarm.Crops.*;
import com.zipcodewilmington.froilansfarm.PartsOfFarm.CropRow;
import com.zipcodewilmington.froilansfarm.PartsOfFarm.FarmHouse;
import com.zipcodewilmington.froilansfarm.PartsOfFarm.Field;
import com.zipcodewilmington.froilansfarm.Vehicles.CropDuster;

public class Person implements NoiseMaker, Eater, Pilot, Rider, Botanist {

    private String name = "";
    private boolean pilot = false;
    private String noise = "Hello";
    int energyLevel = 0;
    boolean onHorse = false;

    public Person(String name, boolean isPilot, String noise, int energy) {

        this.name = name;
        this.pilot = isPilot;
        this.noise = noise;
        this.energyLevel = energy;
        this.onHorse = false;

    }

    public String getName() {
        return name;
    }

    public int getEnergy() {
        return energyLevel;
    }

    public void setEnergy(int energy) {
        this.energyLevel = energy;
    }

    public boolean isPilot() {
        return pilot;
    }

    public String getNoise() {
        return noise;
    }


    public void makeNoise() {
        System.out.println(getNoise());
    }


    public void eat(Food item, int numb) {

        int energyIncrease = 0;
        boolean enough = false;
        if(item instanceof EarOfCorn) {
            enough = EarOfCorn.eatCorn(numb);
            if(enough) energyIncrease = 15 * numb;
        } else if (item instanceof Tomato) {
            enough = Tomato.eatTomato(numb);
            if(enough) energyIncrease = 12 * numb;
        } else if (item instanceof Egg) {
            enough = Egg.eatEgg(numb);
            if(enough) energyIncrease = 25 * numb;
        } else {
            System.out.println("Are you sure what you ate is food?");;
        }

        setEnergy(getEnergy() + energyIncrease);

    }

    public void plant(Crop crop, CropRow cropRow) {

        cropRow.setCrop(crop);
    }

    public void mount(Horse horse) {

        horse.setRidenToday(true);
        this.onHorse = true;
    }

    public void dismount() {
        this.onHorse = false;
    }

    public void fly(Field field) {
        if(!this.pilot) {
            System.out.println("You're not a pilot, you can't fly.");
        } else {
            CropDuster plane = new CropDuster();
            plane.fertilize(field);
            System.out.println("Field has been fertilized.  Nice flying!");
        }
    }
}
