package com.zipcodewilmington.froilansfarm;

import com.zipcodewilmington.froilansfarm.Animals.Chicken;
import com.zipcodewilmington.froilansfarm.Animals.Horse;
import com.zipcodewilmington.froilansfarm.Crops.*;
import com.zipcodewilmington.froilansfarm.PartsOfFarm.*;
import com.zipcodewilmington.froilansfarm.People.Farmer;
import com.zipcodewilmington.froilansfarm.People.Person;
import com.zipcodewilmington.froilansfarm.Vehicles.Aircraft;
import com.zipcodewilmington.froilansfarm.Vehicles.CropDuster;
import com.zipcodewilmington.froilansfarm.Vehicles.Tractor;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class Day2 {

    Farmer froilan = new Farmer("Froilan", true, "Hey, hey, hey!", 30);
    Person froilanda = new Person("Froilanda", true, "Howdy, y'all!", 40);
    Farmer freelan = new Farmer("Freelan", true, "What's up?", 35);

    Horse horse1 = new Horse();
    Horse horse2 = new Horse();
    Horse horse3 = new Horse();
    Horse horse4 = new Horse();
    Horse horse5 = new Horse();
    Horse horse6 = new Horse();
    Horse horse7 = new Horse();
    Horse horse8 = new Horse();
    Horse horse9 = new Horse();
    Stable stable1 = new Stable("Stable 1");
    Stable stable2 = new Stable("Stable 2");
    Stable stable3 = new Stable("Stable 3");

    Chicken chicken1 = new Chicken();
    Chicken chicken2 = new Chicken();
    Chicken chicken3 = new Chicken();
    Chicken chicken4 = new Chicken();
    Chicken chicken5 = new Chicken();
    Chicken chicken6 = new Chicken();
    Chicken chicken7 = new Chicken();
    Chicken chicken8 = new Chicken();
    Chicken chicken9 = new Chicken();
    Chicken chicken10 = new Chicken();
    Chicken chicken11 = new Chicken();
    Chicken chicken12 = new Chicken();
    Chicken chicken13 = new Chicken();
    Chicken chicken14 = new Chicken();
    Chicken chicken15 = new Chicken();
    Chicken chicken16 = new Chicken();
    ChickenCoop coop1 = new ChickenCoop();
    ChickenCoop coop2 = new ChickenCoop();
    ChickenCoop coop3 = new ChickenCoop();
    ChickenCoop coop4 = new ChickenCoop();

    FarmHouse froilansHouse = new FarmHouse();
    Farm froilanFarm = new Farm(3, 4);

    Field field = new Field(5);
    CornStalk cornStalk1 = new CornStalk();
    CropRow row1 = new CropRow(cornStalk1);
    Food corn = new EarOfCorn();
    TomatoPlant tomatoPlant1 = new TomatoPlant();
    CropRow row2 = new CropRow(tomatoPlant1);
    Food tomato = new Tomato();
    CornStalk cornStalk2 = new CornStalk();
    CropRow row3 = new CropRow(cornStalk2);
    TomatoPlant tomatoPlant2 = new TomatoPlant();
    CropRow row4 = new CropRow(tomatoPlant2);
    CornStalk cornStalk3 = new CornStalk();
    CropRow row5 = new CropRow(cornStalk3);
    Egg egg = new Egg();

    FarmVehicle tractor = new Tractor();
    FarmVehicle tractor2 = new Tractor();
    CropDuster cropDuster = new CropDuster();


    @Before
    public void setup() {
        //Given
        stable1.addHorse(horse1);
        stable1.addHorse(horse2);
        stable1.addHorse(horse3);

        stable2.addHorse(horse4);
        stable2.addHorse(horse5);
        stable2.addHorse(horse6);

        stable3.addHorse(horse7);
        stable3.addHorse(horse8);
        stable3.addHorse(horse9);


        coop1.addChicken(chicken1);
        coop1.addChicken(chicken2);
        coop1.addChicken(chicken3);
        coop1.addChicken(chicken4);

        coop2.addChicken(chicken5);
        coop2.addChicken(chicken6);
        coop2.addChicken(chicken7);
        coop2.addChicken(chicken8);

        coop3.addChicken(chicken9);
        coop3.addChicken(chicken10);
        coop3.addChicken(chicken11);
        coop3.addChicken(chicken12);

        coop4.addChicken(chicken13);
        coop4.addChicken(chicken14);
        coop4.addChicken(chicken15);
        coop4.addChicken(chicken16);

        field.addCropRow(row1, 1);
        field.addCropRow(row2, 2);
        field.addCropRow(row3, 3);
        field.addCropRow(row4, 4);
        field.addCropRow(row5, 5);

        froilanFarm.addCoop(coop1);
        froilanFarm.addCoop(coop2);
        froilanFarm.addCoop(coop3);
        froilanFarm.addCoop(coop4);
        froilanFarm.addStable(stable1);
        froilanFarm.addStable(stable2);
        froilanFarm.addStable(stable3);

        EarOfCorn.addCorn(50);
        Tomato.addTomato(30);
        Egg.addEgg(24);

    }

    @Test
    public void testCanFlyFroilanda() {
        //When
        boolean expected = true;
        boolean actual = froilanda.isPilot();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testCropDusterFarmVehicle() {
        //When
        boolean expected = false;
        boolean actual = cropDuster.isAFarmVehicle();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testFertilizeField() {
        //When
        cropDuster.makeNoise();
        froilanda.fly(field);
        boolean expected = true;
        boolean actual = field.isFertilized();

        //Then
        Assert.assertEquals(expected, actual);

    }
}
