package com.zipcodewilmington.froilansfarm;

import com.zipcodewilmington.froilansfarm.Crops.EarOfCorn;
import com.zipcodewilmington.froilansfarm.People.Farmer;
import com.zipcodewilmington.froilansfarm.People.Person;
import org.junit.Assert;
import org.junit.Test;

public class PersonTest {

    @Test
    public void testCreateFarmer() {
        //Given
        Person froilan = new Farmer("Froilan", true, "OHH HELLO!!!", 40);
        String expected = "Froilan";

        //When
        String actual = froilan.getName();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testIsPilot() {
        //Given
        Person froilan = new Farmer("Froilan", true, "OHH HELLO!!!", 40);
        boolean expected = true;

        //When
        boolean actual = froilan.isPilot();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetEnergy() {
        //Given
        Person froilan = new Farmer("Froilan", true, "OHH HELLO!!!", 40);
        int expected = 40;

        //When
        int actual = froilan.getEnergy();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testEat() {
        //Given
        Person froilan = new Farmer("Froilan", true, "OHH HELLO!!!", 40);
        EarOfCorn corn = new EarOfCorn();
        EarOfCorn.addCorn(20);
        int expected = 70;

        //When
        froilan.eat(corn, 2);
        int actual = froilan.getEnergy();

        //Then
        Assert.assertEquals(expected, actual);
    }

}
